
## step II Smoothing  ##

nclust = 41
my.clust=list()
clust.centers=list()
for(chain in 1:nchain){
my.sample.vec=as.numeric(my.sample)
my.which=which(is.na(my.sample.vec))
my.sample.vec[my.which]=0
my.sample0=matrix(my.sample.vec, n, m)
clust=kmeans(my.sample0,nclust)$cluster
zeta=NULL
varht=NULL
clust.initial=matrix(nrow=nclust,ncol=m)

for(kk in 1:nclust){
         label=which(clust==kk)
         temp=NULL
         temp.pred=NULL
         clusti.ini=as.numeric(as.vector(t(my.sample[label,])))
         tm.ini=rep(tt,length(label))
         my.geneid.ini=as.factor(sort(rep(1:length(label),m)))
         my.which=which(as.numeric(is.na(clusti.ini))==0)
         clusti=clusti.ini[my.which]
         tm=tm.ini[my.which]
         my.geneid=my.geneid.ini[my.which]
         formula=~1|my.geneid
         form.wk <- terms.formula(formula)[[2]]
         term.wk <- strsplit(deparse(form.wk), " \\| ")[[1]]
         z2.wk <- eval(parse(text = term.wk[2]))
         z <- NULL
         lvl.z2 <- levels(z2.wk)
         for (k in lvl.z2) z <- cbind(z, as.numeric(z2.wk == k))
         init <- -1
         env <- length(levels(z2.wk))
         fun <- function(zeta, env) diag(10^(-zeta), env)
         sigma <- list(fun = fun, env = env)    	
         my.ran=list(z = z, sigma = sigma, init = init)
         par <- list(nphi=1,mkphi=mkphi.cubic,mkrk=mkrk.cubic,
            env=c(min(tm),max(tm))+c(-1,1)*(max(tm)-min(tm))*.00)

         temp=ssanova(clusti~tm,
                random=my.ran,type=list(tm=list("custom",par)),  id.basis=1:m, alpha=1)
         temp.pred=predict(temp,data.frame(tm=tt,offset=rep(0,length(tt))))
         clust.initial[kk,]=temp.pred
         my.geneid=as.factor(sort(rep(1:length(label),m)))
         formula=~1|my.geneid
         form.wk <- terms.formula(formula)[[2]]
         term.wk <- strsplit(deparse(form.wk), " \\| ")[[1]]
         z2.wk <- eval(parse(text = term.wk[2]))
         z <- NULL
         lvl.z2 <- levels(z2.wk)
         for (k in lvl.z2) z <- cbind(z, as.numeric(z2.wk == k))
         init <- -1
         env <- length(levels(z2.wk))
         fun <- function(zeta, env) diag(10^(-zeta), env)
         sigma <- list(fun = fun, env = env)    	
         my.ran=list(z = z, sigma = sigma, init = init)
         random.zb=my.ran$z%*%temp$b
         temp.pred=predict(temp,data.frame(tm=tt))
         zeta[kk]=temp$zeta
         varht[kk]=temp$varht
         clust.initial[kk,]=temp.pred
         rm(temp)
      ##   print(paste("cluster",kk, "is calculated"), quote = F)
 }

clust.sim=NULL
clust.sim=em.clust(my.sample,tt,clust,nclust,clust.initial,zeta,varht,thres=threshold,iter.max,tol)#
clust.centers[[chain]]=clust.sim$mean.curve
my.zeta<-my.varht<-gamma.prior<-NULL
my.zeta=clust.sim$var.ratio
my.varht=clust.sim$variance
gamma.prior=clust.sim$pp
like.rec[chain]=clust.sim$likelihood
bic.rec[chain]=clust.sim$bic
clust.temp=NULL
for(i in 1:n)
	clust.temp[i]=post(my.sample[i,],nclust,gamma.prior,clust.centers[[chain]],my.zeta,my.varht)$clust
my.clust[[chain]]=clust.temp
}

output.clust=NULL
output.clust=my.clust[[which(bic.rec==min(bic.rec))[1]]]

length = 2020
####   cal.mean = function(length) {
x.select=my.sample
nclass=41
cl=output.clust
pp=dim(x.select)[2]
tt=1:pp
tt.grid=seq(min(tt), max(tt),length=length)
curv=matrix(nrow=nclass,ncol=length(tt.grid))
cdv = matrix(nrow=length-1,ncol=nclass)
ssafit <- list(); length(ssafit) <- nclass

for(i in 1:nclass )
  {
    class=x.select[cl==i,]
    if(is.vector(class)) nn= 1 else nn=dim(class)[1]
    y.ini=as.vector(t(class))
    my.time.ini=rep(tt,nn)
    geneid.ini=as.factor(sort(rep(tt,nn)))
    my.which=which(as.numeric(is.na(y.ini))==0)
    y=y.ini[my.which]
    my.time=my.time.ini[my.which]
    geneid=geneid.ini[my.which]
    formula=~1|geneid
    form.wk <- terms.formula(formula)[[2]]
    term.wk <- strsplit(deparse(form.wk), " \\| ")[[1]]
    z2.wk <- eval(parse(text = term.wk[2]))
    z <- NULL
    lvl.z2 <- levels(z2.wk)
    for (k in lvl.z2) z <- cbind(z, as.numeric(z2.wk == k))
    init <- -1
    env <- length(levels(z2.wk))
    fun <- function(zeta, env) diag(10^(-zeta), env)
    sigma <- list(fun = fun, env = env)    	
    my.ran=list(z = z, sigma = sigma, init = init)
    par <- list(nphi=1,mkphi=mkphi.cubic,mkrk=mkrk.cubic,
            env=c(min(my.time),max(my.time))+c(-1,1)*(max(my.time)-min(my.time))*.00)
            alpha = 5
    if ( i == 4) alpha = 10
    if ( i == 5) alpha = 10
    if ( i == 6) alpha = 3
    if ( i == 8) alpha = 6.9
    if ( i == 11) alpha = 5.5
    if ( i == 12) alpha = 11
    if ( i == 14) alpha = 2
     if ( i == 17) alpha = 4
     if ( i == 19) alpha = 8
      if ( i == 21) alpha = 11.4
      if ( i == 22) alpha = 11
      if ( i == 26) alpha = 4.5
      if ( i == 27) alpha = 8
      if ( i == 28) alpha = 17
      if ( i == 31) alpha = 4
       if ( i == 32) alpha = 4
       if ( i == 36) alpha = 7
       if ( i == 39) alpha = 11
    temp=ssanova(y~my.time, random=my.ran,type=list(my.time=list("custom",par)),  id.basis=rep(tt,1), alpha=alpha)
    tt.grid=seq(min(tt), max(tt),length=length)
    temp.pred=predict(temp,data.frame(my.time=tt.grid),se.fit=FALSE)

#####  RECORD SSANOVA FITTING RESULT FOR EACH CLUSTER FOR LATER PREDICTION AT ARBITRARY TP  ##########

      if ( i  ==  1 )  ssafit1 = temp
    if ( i  ==  2 )  ssafit2 = temp
    if ( i  ==  3 )  ssafit3 = temp
    if ( i  ==  4 )  ssafit4 = temp
    if ( i  ==  5 )  ssafit5 = temp
    if ( i  ==  6 )  ssafit6 = temp
    if ( i  ==  7 )  ssafit7 = temp
    if ( i  ==  8 )  ssafit8 = temp
    if ( i  ==  9 )  ssafit9 = temp
    if ( i  ==  10 )  ssafit10 = temp
    if ( i  ==  11 )  ssafit11 = temp
    if ( i  ==  12 )  ssafit12 = temp
    if ( i  ==  13 )  ssafit13 = temp
    if ( i  ==  14 )  ssafit14 = temp
    if ( i  ==  15 )  ssafit15 = temp
    if ( i  ==  16 )  ssafit16 = temp
    if ( i  ==  17 )  ssafit17 = temp
    if ( i  ==  18 )  ssafit18 = temp
    if ( i  ==  19 )  ssafit19 = temp
    if ( i  ==  20 )  ssafit20 = temp
    if ( i  ==  21 )  ssafit21 = temp
    if ( i  ==  22 )  ssafit22 = temp
    if ( i  ==  23 )  ssafit23 = temp
    if ( i  ==  24 )  ssafit24 = temp
    if ( i  ==  25 )  ssafit25 = temp
    if ( i  ==  26 )  ssafit26 = temp
    if ( i  ==  27 )  ssafit27 = temp
    if ( i  ==  28 )  ssafit28 = temp
    if ( i  ==  29 )  ssafit29 = temp
    if ( i  ==  30 )  ssafit30 = temp
    if ( i  ==  31 )  ssafit31 = temp
    if ( i  ==  32 )  ssafit32 = temp
    if ( i  ==  33 )  ssafit33 = temp
    if ( i  ==  34 )  ssafit34 = temp
    if ( i  ==  35 )  ssafit35 = temp
    if ( i  ==  36 )  ssafit36 = temp
    if ( i  ==  37 )  ssafit37 = temp
    if ( i  ==  38 )  ssafit38 = temp
    if ( i  ==  39 )  ssafit39 = temp
    if ( i  ==  40 )  ssafit40 = temp
    if ( i  ==  41 )  ssafit41 = temp

### save 'temp' ###
    ssafit[[ i ]] = temp
    curv[i,]=temp.pred
}

### record curv in a file ###
write.table(curv, file = paste("C:\\..\\curv.txt"),
      row.names = F, quote=T)
